#!/bin/sh
#
# gallery.sh - Make an HTML-based gallery from XBM images
#
# Written 2005 by Werner Almesberger
#

cat <<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
EOF
if [ -r "$1" ]; then
    echo "<BODY>"
else
    cat <<EOF
<TITLE>`echo "$1" | sed "s/<[^<]*>//g"`</TITLE>
<BODY>
<H1>$1</H1>
EOF
    shift
fi

echo "<TABLE>"
last_dir=
for n in "$@"; do echo "$n"; done | sort |
  while read img; do
    if [ x"${img#/}" = "x$img" ]; then
	url="$img"
    else
	url="file://localhost$img"
    fi
    dir=`echo "$img" | awk -F / '{ if (NF > 1) print $(NF-1) }'`
    file=`basename "$img" .xbm`
    if [ x"$dir" != x"$last_dir" ]; then
	if [ ! -z "$last_dir" ]; then
	    echo "</TR>"
	fi
	echo "<TR><TD><B>$dir</B>"
	last_dir="$dir"
    fi
    cat <<EOF
<TD align=center><A href="$url"><TABLE>
  <TR><TD align=center><IMG src="$url" border=0></TR>
  <TR><TD align=center>$file</TR>
  </TABLE></A>
EOF
  done
cat <<EOF
</TABLE>
</BODY>
</HTML>
EOF
